# CSC 111, Lab 5, Practice Midterm: Part B
#
# Author: Farida Sabry (modified by Sara Mathieson)
# Credit to Maggie Carttar for noticing the issue with reverse(..)
# Also a few people noticed the missing quotes in printing
#
# Determine whether a string is a palindrome


# reverse returns the complete reverse of a string
def reverse(word):
    new_word = ""
    for i in range(len(word)-1,-1,-1): # note this was -2 before
        new_word = new_word + word[i]
    return new_word


# Way 1: see if the word is equal to its reverse
def palindrome(word):
    return word == reverse(word)


# Way 2: compare characters from the start and end, working
# towards the middle. Any inequality, immediately return False.
# If we got to the very end, return True.
'''def palindrome(word):
    half_len = int(len(word)/2)
    for i in range(half_len):
        if word[i] != word[-1-i]:
            return False
    return True'''


# in main, check whether a string is a palindrome
# if Yes: print "palindrome square"
# if No: print what the palindrome would be using reverse
def main():
    string = input("Enter a string: ")

    # case 1: string is a palindrome
    if palindrome(string):
        print("\n>> " + string, "is a palindrome\n")
        for i in range(len(string)):

            # print the string at the beginning and end
            if i == 0 or i == len(string)-1:
                print(string)
                
            # in the middle, print stars surrounded by the letters
            else:
                stars = "*" * (len(string)-2)
                print(string[i] + stars + string[i])

    # case 2: string is not a palindrome
    else:
        print("\n>> " + string, "is not a palindrome\n")
        print(string + reverse(string))

main()
